package sillysagiri.scene;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

import sillysagiri.BMF;
import sillysagiri.Scene;
import sillysagiri.Utils;

public class MainMenu extends Scene {
  private long counter = 0;
  private int state = 0;

  private BMF bmf_white;
  private BMF bmf_blue;

  private Image img_bg;
  private Image img_box;
  private Image img_bandai;
  private Image img_head1;
  private Image img_head2;
  private Image img_head3;
  private Image img_head4;
  private Image img_arrow;

  private String[] list_strmenu;
  
  public void Preload() {
    try {
      bmf_white = BMF.Create("/silly/bmf/onds12_0.silly.gz", "/silly/bmf/onds12.fnt", 0xffffffff);
      bmf_blue = BMF.Create("/silly/bmf/onds12_0.silly.gz", "/silly/bmf/onds12.fnt", 0xff00dbff);
      bmf_blue.lineHeight = (short)(bmf_blue.lineHeight*1.5);
      Image img_loop = Image.createImage("/m_2.png");
      img_bandai = Image.createImage("/c_0.png");

      int loopCount = (int)Math.ceil((float)Utils.GetScreenHeight()/img_loop.getHeight());

      img_bg = Image.createImage(img_loop.getWidth(), Utils.GetScreenHeight());
      Utils.Clear_Image(img_bg, 255, 108, 0);
      Graphics g_bg = img_bg.getGraphics();

      for (int i = 0; i<loopCount; i++)
        g_bg.drawImage(img_loop, 0, i*img_loop.getHeight(), Graphics.LEFT | Graphics.TOP);

      int maxlength = 0;
      list_strmenu = Utils.Get_StringSilly("/silly/txt/t_mainmenu.silly", 7);
      for (int i=0; i<list_strmenu.length; i++)
      {
        if (list_strmenu[i].length() >= list_strmenu[maxlength].length())
          maxlength = i;
        
        list_strmenu[i] = list_strmenu[i].toUpperCase();
      }

      System.out.println(list_strmenu[maxlength]);

      int boxw = (int)(bmf_blue.Measure(list_strmenu[maxlength])[0]+bmf_blue.lineHeight*1.4);
      int boxh = bmf_blue.lineHeight*(list_strmenu.length+1);
      int[] temp = new int[boxw*boxh];
      for (int i=0; i<temp.length; i++) temp[i] = 0x93800000;
      img_box = Image.createRGBImage(temp, boxw, boxh, true);
      temp = null;

      img_head1 = Image.createImage("/bF_0.png");
      img_head2 = Image.createImage("/bF_1.png");
      img_head3 = Image.createImage("/bF_4.png");
      img_head4 = Image.createImage("/bF_2.png");
      img_arrow = Image.createImage("/i_0.png");
    }
    catch(Exception e)
    {
      e.printStackTrace();
      sagiri.Set_Scene(new DeathError(e));
    }
  }

  public void Destroy() {
  }

  public void Update(long dt, Graphics g) {
    counter += dt;

    switch (state) {
      case 0:
      {
        Utils.Clear_Screen(g, 255, 108, 0);
        g.drawImage(img_bg, 0, 0, Graphics.TOP | Graphics.LEFT);

        g.drawImage(
          img_bandai,
          Utils.GetScreenWidth()/2, Utils.GetScreenHeight()/2,
          Graphics.VCENTER | Graphics.HCENTER);

        if (counter >= 600) counter = 0;
        if (counter < 400)
          bmf_white.DrawEx(g, 
            "PRESS ANY KEY",
            Utils.GetScreenWidth()/2, (int)(Utils.GetScreenHeight()*0.7),
            Graphics.VCENTER | Graphics.HCENTER);

        if (sagiri.input.IsKeyDownAny())
        {
          counter = 0;
          state = 1;
        }
      }
      break;

      case 1:
      {
        Utils.Clear_Screen(g, 255, 108, 0);
        g.drawImage(img_bg, 0, 0, Graphics.TOP | Graphics.LEFT);

        int padding = 3;
        g.drawImage(img_head1, padding, padding, Graphics.LEFT | Graphics.TOP);
        g.drawImage(img_head2, Utils.GetScreenWidth()-padding, padding, Graphics.RIGHT | Graphics.TOP);
        g.drawImage(img_head3, padding, Utils.GetScreenHeight()-padding, Graphics.LEFT | Graphics.BOTTOM);
        g.drawImage(img_head4, Utils.GetScreenWidth()-padding, Utils.GetScreenHeight()-5, Graphics.RIGHT | Graphics.BOTTOM);

        int cursor = (int)(Utils.GetScreenHeight()*0.35);
        g.drawImage(img_box, Utils.GetScreenWidth()/2, cursor-(bmf_blue.lineHeight/2), Graphics.HCENTER | Graphics.TOP);

        for(int i=0; i<list_strmenu.length; i++)
          bmf_blue.DrawEx(g, list_strmenu[i], Utils.GetScreenWidth()/2, cursor+bmf_blue.lineHeight*i, Graphics.HCENTER | Graphics.TOP);
        
        // bmf_blue.DrawEx(g, "NEW GAME", Utils.GetScreenWidth()/2, cursor, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "LOAD GAME", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "INSTRUCTION", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "OPTIONS", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "LEADERBOARD", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "CREDITS", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);
        // bmf_blue.DrawEx(g, "EXIT GAME", Utils.GetScreenWidth()/2, cursor+=bmf_blue.lineHeight, Graphics.HCENTER | Graphics.TOP);

        // if (counter > 360) counter = 0;

        padding = (int)(Math.sin((float)counter/200) * 3) + 3;
        cursor = (int)(Utils.GetScreenHeight()*0.35);

        g.drawRegion(
          img_arrow,
          0, 0, 
          img_arrow.getWidth()/2, img_arrow.getHeight(),
          Sprite.TRANS_NONE,
          (Utils.GetScreenWidth()/2) + (img_box.getWidth()/2)+padding, cursor,
          Graphics.LEFT | Graphics.TOP);

        g.drawRegion(
          img_arrow,
          img_arrow.getWidth()/2, 0, 
          img_arrow.getWidth()/2, img_arrow.getHeight(),
          Sprite.TRANS_NONE,
          (Utils.GetScreenWidth()/2) - (img_box.getWidth()/2)-padding, cursor,
          Graphics.RIGHT | Graphics.TOP);
      }
      break;
    
      default: break;
    }
  }
}

